"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigRequest = void 0;
const is = require("predicates");
const assertNotBlank = is.assert(is.notBlank, 'Config "path" cannot be blank');
class ConfigRequest {
    constructor(path, defaultValue) {
        this.path = path;
        this.defaultValue = defaultValue;
        assertNotBlank(this.path);
        this.hasDefaultValue = arguments.length > 1;
        Object.freeze(this);
    }
    static create(path, defaultValue) {
        return new (Function.prototype.bind.apply(ConfigRequest, [null, ...arguments]));
    }
}
exports.ConfigRequest = ConfigRequest;
