import { AnnotationPredicate, ServiceName, DefinitionPredicate } from './types';
import { Container } from './Container';
import { Definition } from './Definition';
import { Lookup } from './Lookup';
import { ContainerArg } from './ContainerArg';
import { TypeRef } from './TypeRef';
export declare class Reference extends ContainerArg {
    private readonly type;
    private readonly lookup;
    static one: {
        name(name: ServiceName): Reference;
        predicate(predicate: DefinitionPredicate): Reference;
        annotation(predicate: AnnotationPredicate): Reference;
        type(type: TypeRef): Reference;
    };
    static multi: {
        predicate(predicate: DefinitionPredicate): Reference;
        annotation(predicate: AnnotationPredicate): Reference;
        type(type: TypeRef): Reference;
    };
    constructor(type: 'one' | 'multi', lookup: Lookup);
    getArgument(container: Container): Promise<any>;
    getDependentServices(container: Container): Definition | Definition[];
    private findDefinitions;
    private findOne;
    private findMulti;
}
