"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAnnotationFactory = void 0;
const is = require("predicates");
const Annotation_1 = require("./decorators/Annotation");
function createAnnotationFactory(annotationName, extraAttributesFactory) {
    const factory = ((...args) => {
        const annotation = {};
        if (extraAttributesFactory) {
            const attributes = extraAttributesFactory(...args);
            if (is.object(attributes)) {
                Object.assign(annotation, attributes);
            }
        }
        annotation.name = annotationName;
        return annotation;
    });
    factory.predicate = is.prop('name', is.equal(annotationName));
    factory.decorator = (...args) => {
        return (clazz) => {
            Annotation_1.Annotation(factory(...args))(clazz);
        };
    };
    return factory;
}
exports.createAnnotationFactory = createAnnotationFactory;
