"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Annotation = void 0;
const serviceMetadata_1 = require("../serviceMetadata");
const Service_1 = require("./Service");
function Annotation(annotation) {
    return (clazz) => {
        const definition = Service_1.getDefinitionForClass(clazz);
        if (definition) {
            definition.annotate(annotation);
        }
        serviceMetadata_1.ensureMetadata(clazz).annotations.push(annotation);
    };
}
exports.Annotation = Annotation;
