"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = void 0;
const ConfigRequest_1 = require("../ConfigRequest");
const serviceMetadata_1 = require("../serviceMetadata");
function Config(path, defaultValue) {
    const request = ConfigRequest_1.ConfigRequest.create.apply(null, Array.prototype.slice.call(arguments));
    return function (target, property, indexOrDescriptor) {
        const isParameterDecorator = typeof indexOrDescriptor === 'number';
        if (isParameterDecorator) {
            serviceMetadata_1.ensureMetadata(target).constructorArguments[indexOrDescriptor] = request;
        }
        else {
            serviceMetadata_1.ensureMetadata(target.constructor).propertiesInjectors.set(property, request);
        }
    };
}
exports.Config = Config;
